﻿using System.Collections.Generic;
using System.Linq;
using System.Xml;
using Microsoft.Maps.MapControl;

namespace Gildor.HeatMapDemos.SL
{
    public class HeatPointLoader
    {
        private Location[] _locations;

        /// <summary>
        /// Gets the heat point locations.
        /// </summary>
        /// <value>The locations.</value>
        public Location[] Locations
        {
            get
            {
                if (null == _locations)
                {
                    _locations = readLocations ().ToArray ();
                }
                return _locations;
            }
        }

        private IEnumerable<Location> readLocations ()
        {
            var reader = XmlReader.Create ("/Gildor.HeatMapDemos.SL;component/HeatPointLocations/locations.xml");

            while (reader.ReadToFollowing ("location"))
            {
                yield return new Location (
                    double.Parse (reader.GetAttribute ("latitude")),
                    double.Parse (reader.GetAttribute ("longitude")));
            }

            reader.Close ();
        }
    }
}
